QUESTS_DISPLAYED = 27;
MAX_QUESTS = 25;
MAX_OBJECTIVES = 10;
UPDATE_DELAY = 0.1;
MAX_NUM_PARTY_MEMBERS = 4;
MAX_QUESTLOG_QUESTS = 25;
QUESTLOG_QUEST_HEIGHT = 16;

QUESTGURU_VERSION = "0.4.2";
QUESTGURU_NUMTABS = 2;

QuestGuru_Settings = {};
QuestGuru_Settings.Tracker = {};
QuestGuru_StartTime = {};
QuestGuru_Player = "";

function QuestGuru_TabClick(id)
	PanelTemplates_SetTab(QuestGuru_QuestLogFrame, id);
	for i=1, QUESTGURU_NUMTABS do
		_G["QuestGuru_TabPage"..i]:Hide();
	end
	_G["QuestGuru_TabPage"..id]:Show();

    local scrollOffset = FauxScrollFrame_GetOffset(QuestGuru_QuestLogListScrollFrame)
    local n = QuestGuru_QuestLogFrame.selectedButtonID - scrollOffset;
    if (n>0 and n<=QUESTS_DISPLAYED) then
		getglobal("QuestGuru_QuestLogTitle"..n):Click();
	end
    local scrollOffset = FauxScrollFrame_GetOffset(QuestGuru_QuestHistoryListScrollFrame)
    local n = QuestGuru_currHistory - scrollOffset;
    if (n>0 and n<=QUESTS_DISPLAYED) then
		getglobal("QuestGuru_QuestHistoryTitle"..n):Click();
	end
end

local old_ToggleQuestLog = ToggleQuestLog;
function ToggleQuestLog()
	if ( QuestGuru_QuestLogFrame:IsShown() ) then
		HideUIPanel(QuestGuru_QuestLogFrame);
	else
		ShowUIPanel(QuestGuru_QuestLogFrame);
	end
end

local old_QuestLogTitleButton_OnLoad = QuestLogTitleButton_OnLoad;
function QuestLogTitleButton_OnLoad()
	this:RegisterForClicks("LeftButtonUp", "RightButtonUp");
	this:RegisterEvent("UNIT_QUEST_LOG_CHANGED");
	this:RegisterEvent("PARTY_MEMBER_ENABLE");
	this:RegisterEvent("PARTY_MEMBER_DISABLE");
end

local old_QuestLogTitleButton_OnEvent = QuestLogTitleButton_OnEvent;
function QuestLogTitleButton_OnEvent(event)
	if ( GameTooltip:IsOwned(this) ) then
		GameTooltip:Hide();
		QuestLog_UpdatePartyInfoTooltip();
	end
end

local old_QuestLog_OnLoad = QuestLog_OnLoad;
function QuestLog_OnLoad()
	PanelTemplates_SetNumTabs(QuestGuru_QuestLogFrame, QUESTGURU_NUMTABS);
	PanelTemplates_SetTab(QuestGuru_QuestLogFrame, 1);
	QuestGuru_TabPage1:Show();
	this.selectedButtonID = 2;
	getglobal("QuestGuru_QuestLogTitle"..this.selectedButtonID):Click();
	this:RegisterEvent("QUEST_LOG_UPDATE");
	this:RegisterEvent("QUEST_WATCH_UPDATE");
	this:RegisterEvent("UPDATE_FACTION");
	this:RegisterEvent("UNIT_QUEST_LOG_CHANGED");
	this:RegisterEvent("PARTY_MEMBERS_CHANGED");
	this:RegisterEvent("PARTY_MEMBER_ENABLE");
	this:RegisterEvent("PARTY_MEMBER_DISABLE");
	tinsert(UISpecialFrames, "QuestGuru_QuestLogFrame");
	this:RegisterEvent("QUEST_COMPLETE");
	this:RegisterEvent("VARIABLES_LOADED");
	QuestGuru_QuestLogTitleText:SetText("QuestGuru v"..QUESTGURU_VERSION);
	
	QuestLogFrame = QuestGuru_QuestLogFrame;
	QuestLogListScrollFrame = QuestGuru_QuestLogListScrollFrame;
	QuestLogDetailScrollChildFrame = QuestGuru_QuestLogDetailScrollChildFrame;
	QuestLogQuestTitle = QuestGuru_QuestLogQuestTitle;
end

local old_QuestLog_OnEvent = QuestLog_OnEvent;
function QuestLog_OnEvent()
	if ( event == "QUEST_LOG_UPDATE" or event == "UPDATE_FACTION" or (event == "UNIT_QUEST_LOG_CHANGED" and arg1 == "player")) then
		QuestLog_Update();
		QuestWatch_Update();
		if ( QuestGuru_QuestLogFrame:IsVisible() ) then
			QuestLog_UpdateQuestDetails(1);
		end
	elseif ( event == "QUEST_WATCH_UPDATE" ) then
		if ( AUTO_QUEST_WATCH == "1" and GetNumQuestLeaderBoards(arg1) > 0 ) then
			AddQuestWatch(arg1);
			QuestLog_Update();
			QuestWatch_Update();
		end
	elseif (event=="QUEST_COMPLETE") then
		-- Save Current Quest info
		QuestGuru_LastCompleteQuest.Title = GetTitleText();
		QuestGuru_SaveLastQuest();
	elseif (event == "VARIABLES_LOADED") then
		QuestGuru_Player = UnitName("player"); --.."-"..GetRealmName();
		if (QuestGuru_History == nil) then
			QuestGuru_History = {};
		end
		QuestGuru_CheckHistoryVersion();
		QuestGuru_UpdateHistory();

		if (QuestGuru_Settings == nil) then
			QuestGuru_Settings = {};
		end
		if (QuestGuru_Settings.Tracker == nil) then
		    QuestGuru_Settings.Tracker = {};
		end
		if (QuestGuru_Settings.Tracker.Enabled ~= false) then
		    QuestGuru_Settings.Tracker.Enabled = true;
		end
		if (QuestGuru_Settings.Tracker.Enabled) then
			QuestGuru_OptionsFrameTrackerEnabledToggle:SetChecked(1);
		end
		if (QuestGuru_Settings.Tracker.Scale == nil) then
		    QuestGuru_Settings.Tracker.Scale = 0.9;
		end
		QuestGuru_OptionsFrameTrackerScaleText:SetText("Tracker Size ("..ceil((QuestGuru_Settings.Tracker.Scale * 100)-0.5).."%)");
		QuestGuru_OptionsFrameTrackerScale:SetValue(QuestGuru_Settings.Tracker.Scale);
		QuestGuru_QuestWatchFrame:SetScale(QuestGuru_Settings.Tracker.Scale);

		if (QuestGuru_Settings.Tracker.Alpha == nil) then
			QuestGuru_Settings.Tracker.Alpha = 0.7;
		end
		QuestGuru_QuestWatchFrame:SetBackdropColor(0,0,0,QuestGuru_Settings.Tracker.Alpha);
		QuestGuru_OptionsFrameTrackerAlphaText:SetText("Background Alpha ("..abs(ceil((QuestGuru_Settings.Tracker.Alpha * 100)-0.5)).."%)");
		QuestGuru_OptionsFrameTrackerAlpha:SetValue(QuestGuru_Settings.Tracker.Alpha);

		if (QuestGuru_Settings.Tracker.ShowHeaders ~= false) then
			QuestGuru_Settings.Tracker.ShowHeaders = true;
		end
		if (QuestGuru_Settings.Tracker.ShowHeaders) then
			QuestGuru_OptionsFrameTrackerHeadersToggle:SetChecked(1);
		end
		
		if (QuestGuru_Settings.Tracker.BorderStyle == nil) then
			QuestGuru_Settings.Tracker.BorderStyle = 2;
		end
		QuestGuru_SetWatchBorder(QuestGuru_Settings.Tracker.BorderStyle);
		UIDropDownMenu_SetSelectedID(QuestGuru_OptionsFrameTrackerBorderDropDown, QuestGuru_Settings.Tracker.BorderStyle);
		
		QuestLog_SetHistorySelection(QuestGuru_currHistory);
		QuestWatch_Update();
	else
		QuestLog_Update();
		if ( event == "PARTY_MEMBERS_CHANGED" ) then
			-- Determine whether the selected quest is pushable or not
			if ( GetQuestLogPushable() and GetNumPartyMembers() > 0 ) then
				QuestGuru_QuestFramePushQuestButton:Enable();
			else
				QuestGuru_QuestFramePushQuestButton:Disable();
			end
		end
	end

end

local old_QuestRewardCompleteButton_OnClick = QuestRewardCompleteButton_OnClick;
function QuestRewardCompleteButton_OnClick()
	local inserted = false;
--	DEFAULT_CHAT_FRAME:AddMessage("Quest Complete: "..QuestGuru_LastCompleteQuest.Title);
	if ( QuestFrameRewardPanel.itemChoice == 0 and GetNumQuestChoices() > 0 ) then
		old_QuestRewardCompleteButton_OnClick();
		return;
	end
	
	if (QuestGuru_LastCompleteQuest.Level ==  nil) then
		old_QuestRewardCompleteButton_OnClick();
		return;
	end

	for i, qH in ipairs(QuestGuru_History) do
		if (qH.Header == QuestGuru_LastCompleteQuest.Header) then
			if (qH.Level == QuestGuru_LastCompleteQuest.Level) then
				if (qH.Title == QuestGuru_LastCompleteQuest.Title and qH.Daily == 1) then
					if (qH.Count == nil) then qH.Count = 1 end
					qH.Count = qH.Count + 1;
					inserted = true;
					break;
				end
				if (qH.Title > QuestGuru_LastCompleteQuest.Title) then
					tinsert(QuestGuru_History, i, QuestGuru_LastCompleteQuest);
					inserted = true;
					break;
				end
			elseif (qH.Level > QuestGuru_LastCompleteQuest.Level) then
				tinsert(QuestGuru_History, i, QuestGuru_LastCompleteQuest);
				inserted = true;
				break;
			end
		elseif (qH.Header > QuestGuru_LastCompleteQuest.Header) then
			tinsert(QuestGuru_History, i, QuestGuru_LastCompleteQuest);
			inserted = true;
			break;
		end
	end
	if (not inserted) then
		tinsert(QuestGuru_History, QuestGuru_LastCompleteQuest);
		inserted = true;
	end
	QuestGuru_WatchList[QuestGuru_LastCompleteQuest.Title] = nil;
	QuestGuru_StartTime[QuestGuru_LastCompleteQuest.Title] = nil;
	QuestGuru_LastCompleteQuest = {};
	QuestGuru_UpdateHistory();
	old_QuestRewardCompleteButton_OnClick();
end

local old_QuestDetailAcceptButton_OnClick = QuestDetailAcceptButton_OnClick;
function QuestDetailAcceptButton_OnClick()
	local questTitle = GetTitleText();
	QuestGuru_StartTime[questTitle] = date("%m/%d/%Y %H:%M:%S");
	AcceptQuest();
end

local old_QuestLog_OnShow = QuestLog_OnShow;
function QuestLog_OnShow()
	UpdateMicroButtons();

	if ( QuestGuru_QuestLogFrame:IsShown() ) then
		QuestLogMicroButton:SetButtonState("PUSHED", 1);
	else
		QuestLogMicroButton:SetButtonState("NORMAL");
	end

	PanelTemplates_SetTab(QuestGuru_QuestLogFrame, 1);
	QuestGuru_TabPage1:Show();
	QuestGuru_TabPage2:Hide();

    local scrollOffset = FauxScrollFrame_GetOffset(QuestGuru_QuestLogListScrollFrame)
    local n = QuestGuru_QuestLogFrame.selectedButtonID - scrollOffset;
    if (n>0 and n<=QUESTS_DISPLAYED) then
		getglobal("QuestGuru_QuestLogTitle"..n):Click();
	end
    local scrollOffset = FauxScrollFrame_GetOffset(QuestGuru_QuestHistoryListScrollFrame)
    local n = QuestGuru_currHistory - scrollOffset;
    if (n>0 and n<=QUESTS_DISPLAYED) then
		getglobal("QuestGuru_QuestHistoryTitle"..n):Click();
	end

	PlaySound("igQuestLogOpen");
	QuestLog_SetSelection(GetQuestLogSelection());
	QuestLog_Update();
end

local old_QuestLog_OnHide = QuestLog_OnHide;
function QuestLog_OnHide()
	UpdateMicroButtons();

	if ( QuestGuru_QuestLogFrame:IsShown() ) then
		QuestLogMicroButton:SetButtonState("PUSHED", 1);
	else
		QuestLogMicroButton:SetButtonState("NORMAL");
	end

	PlaySound("igQuestLogClose");
end

local old_QuestLog_OnUpdate = QuestLog_OnUpdate;
function QuestLog_OnUpdate(elapsed)
	if ( QuestGuru_QuestLogFrame.hasTimer ) then
		QuestGuru_QuestLogFrame.timePassed = QuestGuru_QuestLogFrame.timePassed + elapsed;
		if ( QuestGuru_QuestLogFrame.timePassed > UPDATE_DELAY ) then
			QuestGuru_QuestLogTimerText:SetText(TIME_REMAINING.." "..SecondsToTime(GetQuestLogTimeLeft()));
			QuestGuru_QuestLogFrame.timePassed = 0;		
		end
	end
end

local old_QuestLog_Update = QuestLog_Update;
function QuestLog_Update()
	local numEntries, numQuests = GetNumQuestLogEntries();
	
	if ( numEntries == 0 ) then
		QuestGuru_EmptyQuestLogFrame:Show();
		QuestGuru_QuestLogFrameAbandonButton:Disable();
		QuestGuru_QuestLogFrame.hasTimer = nil;
		QuestGuru_QuestLogDetailScrollFrame:Hide();
	else
		QuestGuru_EmptyQuestLogFrame:Hide();
		QuestGuru_QuestLogFrameAbandonButton:Enable();
		QuestGuru_QuestLogDetailScrollFrame:Show();
	end

	-- Update Quest Count
	QuestLogUpdateQuestCount(numQuests);
	QuestGuru_QuestLogFrameTab1:SetText("Current ("..numQuests..")");

	-- ScrollFrame update
	FauxScrollFrame_Update(QuestGuru_QuestLogListScrollFrame, numEntries, QUESTS_DISPLAYED, QUESTLOG_QUEST_HEIGHT, nil, nil, nil, QuestGuru_QuestLogHighlightFrame, 293, 316 )
	
	-- Update the quest listing
	QuestGuru_QuestLogHighlightFrame:Hide();

	-- If no selection then set it to the first available quest
	if ( GetQuestLogSelection() == 0 ) then
		QuestLog_SetFirstValidSelection();
	end

	local questIndex, questLogTitle, questTitleTag, questNumGroupMates, questNumGuildMates, questNormalText, questHighlight, questCheck;
	local questLogTitleText, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete, isDaily, color;
	local numPartyMembers, partyMembersOnQuest, tempWidth, textWidth;
	local questTagText, strLvl;
	for i=1, QUESTS_DISPLAYED, 1 do
		questIndex = i + FauxScrollFrame_GetOffset(QuestGuru_QuestLogListScrollFrame);
		questLogTitle = getglobal("QuestGuru_QuestLogTitle"..i);
		questTitleTag = getglobal("QuestGuru_QuestLogTitle"..i.."Tag");
		questNumGroupMates = getglobal("QuestGuru_QuestLogTitle"..i.."GroupMates");
		questNumGuildMates = getglobal("QuestGuru_QuestLogTitle"..i.."GuildMates");
		questCheck = getglobal("QuestGuru_QuestLogTitle"..i.."Check");
		questNormalText = getglobal("QuestGuru_QuestLogTitle"..i.."NormalText");
		questHighlight = getglobal("QuestGuru_QuestLogTitle"..i.."Highlight");
		if ( questIndex <= numEntries ) then
			questLogTitleText, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete, isDaily = GetQuestLogTitle(questIndex);
			if (QuestGuru_StartTime[questLogTitleText] == nil) then
				QuestGuru_StartTime[questLogTitleText] = date("%m/%d/%Y %H:%M:%S");
			end
			if ( isHeader ) then
				if ( questLogTitleText ) then
					questLogTitle:SetText(questLogTitleText);
				else
					questLogTitle:SetText("");
				end
				
				if ( isCollapsed ) then
					questLogTitle:SetNormalTexture("Interface\\Buttons\\UI-PlusButton-Up");
				else
					questLogTitle:SetNormalTexture("Interface\\Buttons\\UI-MinusButton-Up"); 
				end
				questHighlight:SetTexture("Interface\\Buttons\\UI-PlusButton-Hilight");
				questNumGroupMates:SetText("");
				questCheck:Hide();
			else
				strLvl = " ["..level
				if (questTag ~= nil) then
					if ((questTag == "Group") and (suggestedGroup > 0)) then
						strLvl = strLvl.."G"..suggestedGroup;
					elseif (questTag == "Dungeon") then
						strLvl = strLvl.."D";
					else
						strLvl = strLvl.."+"
					end
				end
				strLvl = strLvl.."] "
				questLogTitle:SetText(strLvl..questLogTitleText);
				--Set Dummy text to get text width *SUPER HACK*
				QuestGuru_QuestLogDummyText:SetText(strLvl..questLogTitleText);

				questLogTitle:SetNormalTexture("");
				questHighlight:SetTexture("");

				-- If not a header see if any nearby group mates are on this quest
				numPartyMembers = GetNumPartyMembers();
				if ( numPartyMembers == 0 ) then
					--return;
				end
				partyMembersOnQuest = 0;
				for j=1, numPartyMembers do
					if ( IsUnitOnQuest(questIndex, "party"..j) ) then
						partyMembersOnQuest = partyMembersOnQuest + 1;
					end
				end
				if ( partyMembersOnQuest > 0 ) then
					questNumGroupMates:SetText("["..partyMembersOnQuest.."]");
				else
					questNumGroupMates:SetText("");
				end
				
				questNumGuildMates:SetText("");
			end
			-- Save if its a header or not
			questLogTitle.isHeader = isHeader;

			if ( isComplete and isComplete < 0 ) then
				questTag = FAILED;
			elseif ( isComplete and isComplete > 0 ) then
				questTag = COMPLETE;
			elseif ( isDaily ) then
				if ( questTag ) then
					questTag = format(DAILY_QUEST_TAG_TEMPLATE, questTag);
				else
					questTag = DAILY;
				end
			end
			if ( questTag ) then
			    if ((questTag == "Group") and (suggestedGroup == 0)) then
			        questTag = "Elite";
				end
				questTagText = "("..questTag
				if ((suggestedGroup ~= nil) and (suggestedGroup > 0) and (questTag ~= COMPLETE)) then
					questTagText = questTagText..":"..suggestedGroup;
				end
				questTagText = questTagText..")";
				questTitleTag:SetText(questTagText);
				-- Shrink text to accomdate quest tags without wrapping
				tempWidth = 275 - 15 - questTitleTag:GetWidth();
				
				if ( QuestGuru_QuestLogDummyText:GetWidth() > tempWidth ) then
					textWidth = tempWidth;
				else
					textWidth = QuestGuru_QuestLogDummyText:GetWidth();
				end
				
				questNormalText:SetWidth(tempWidth);
				
				-- If there's quest tag position check accordingly
				questCheck:Hide();
				if ( IsQuestWatched(questIndex) ) then
					if ( questNormalText:GetWidth() + 24 < 275 ) then
						questCheck:SetPoint("LEFT", questLogTitle, "LEFT", textWidth+24, 0);
					else
						questCheck:SetPoint("LEFT", questLogTitle, "LEFT", textWidth+10, 0);
					end
					questCheck:Show();
				end
			else
				questTitleTag:SetText("");
				questNormalText:SetWidth(275);

				-- Show check if quest is being watched
				questCheck:Hide();
				if ( IsQuestWatched(questIndex) ) then
					if ( questNormalText:GetWidth() + 24 < 275 ) then
						questCheck:SetPoint("LEFT", questNormalText, "LEFT", questNormalText:GetWidth()+24, 0);
					else
						questCheck:SetPoint("LEFT", questNormalText, "LEFT", questNormalText:GetWidth()-10, 0);
					end
					questCheck:Show();
				end
			end

			-- Color the quest title and highlight according to the difficulty level
			local playerLevel = UnitLevel("player");
			if ( isHeader ) then
				color = QuestDifficultyColor["header"];
			else
				color = GetDifficultyColor(level);
			end
			questTitleTag:SetTextColor(color.r, color.g, color.b);
			questLogTitle:SetTextColor(color.r, color.g, color.b);
			questNumGroupMates:SetTextColor(color.r, color.g, color.b);
			
			local info = ChatTypeInfo["GUILD"];
			questNumGuildMates:SetTextColor(info.r, info.g, info.b);

			questLogTitle.r = color.r;
			questLogTitle.g = color.g;
			questLogTitle.b = color.b;
			questLogTitle:Show();

			-- Place the highlight and lock the highlight state
			if ( QuestGuru_QuestLogFrame.selectedButtonID and (GetQuestLogSelection() == questIndex) ) then
				QuestGuru_QuestLogHighlightFrame:SetPoint("TOPLEFT", "QuestGuru_QuestLogTitle"..i, "TOPLEFT", 0, 0);
				QuestGuru_QuestLogSkillHighlight:SetVertexColor(questLogTitle.r, questLogTitle.g, questLogTitle.b);
				QuestGuru_QuestLogHighlightFrame:Show();
				questTitleTag:SetTextColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
				questLogTitle:LockHighlight();
			else
				questLogTitle:UnlockHighlight();
			end

		else
			questLogTitle:Hide();
		end
	end

	-- Determine whether the selected quest is pushable or not
	if ( numEntries == 0 ) then
		QuestGuru_QuestFramePushQuestButton:Disable();
	elseif ( GetQuestLogPushable() and GetNumPartyMembers() > 0 ) then
		QuestGuru_QuestFramePushQuestButton:Enable();
	else
		QuestGuru_QuestFramePushQuestButton:Disable();
	end
	
--	QuestGuru_UpdateHistory();
end

local old_QuestLog_SetSelection = QuestLog_SetSelection;
function QuestLog_SetSelection(questID)
	local selectedQuest;
	if ( questID == 0 ) then
		QuestGuru_QuestLogDetailScrollFrame:Hide();
		return;
	end

	-- Get xml id
	local id = questID - FauxScrollFrame_GetOffset(QuestGuru_QuestLogListScrollFrame);
	
	SelectQuestLogEntry(questID);
	local titleButton = getglobal("QuestGuru_QuestLogTitle"..id);
	local titleButtonTag = getglobal("QuestGuru_QuestLogTitle"..id.."Tag");
	local questLogTitleText, level, questTag, suggestedGroup, isHeader, isCollapsed = GetQuestLogTitle(questID);
	if ( isHeader ) then
		if ( isCollapsed ) then
			ExpandQuestHeader(questID);
			return;
		else
			CollapseQuestHeader(questID);
			return;
		end
	else
		-- Set newly selected quest and highlight it
		QuestGuru_QuestLogFrame.selectedButtonID = questID;
		local scrollFrameOffset = FauxScrollFrame_GetOffset(QuestGuru_QuestLogListScrollFrame);
		if ( questID > scrollFrameOffset and questID <= (scrollFrameOffset + QUESTS_DISPLAYED) and questID <= GetNumQuestLogEntries() ) then
			titleButton:LockHighlight();
			titleButtonTag:SetTextColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
			QuestGuru_QuestLogSkillHighlight:SetVertexColor(titleButton.r, titleButton.g, titleButton.b);
			QuestGuru_QuestLogHighlightFrame:SetPoint("TOPLEFT", "QuestGuru_QuestLogTitle"..id, "TOPLEFT", 5, 0);
			QuestGuru_QuestLogHighlightFrame:Show();
		end
	end
	QuestLog_UpdateQuestDetails();
end

local old_QuestLog_UpdateQuestDetails = QuestLog_UpdateQuestDetails;
function QuestLog_UpdateQuestDetails(doNotScroll)
	local questID = GetQuestLogSelection();
	local questTitle = GetQuestLogTitle(questID);
	local lastObjective;
	
	if ( not questTitle ) then
		questTitle = "";
	end
	if ( IsCurrentQuestFailed() ) then
		questTitle = questTitle.." - ("..FAILED..")";
	end
	QuestGuru_QuestLogQuestTitle:SetText(questTitle);

	local questDescription;
	local questObjectives;
	questDescription, questObjectives = GetQuestLogQuestText();
	if (QuestGuru_StartTime[questTitle] ~= nil) then
		questObjectives = "Started: "..QuestGuru_StartTime[questTitle].."\n\n"..questObjectives;
	end
	QuestGuru_QuestLogObjectivesText:SetText(questObjectives);
	
	local questTimer = GetQuestLogTimeLeft();
	if ( questTimer ) then
		QuestGuru_QuestLogFrame.hasTimer = 1;
		QuestGuru_QuestLogFrame.timePassed = 0;
		QuestGuru_QuestLogTimerText:Show();
		QuestGuru_QuestLogTimerText:SetText(TIME_REMAINING.." "..SecondsToTime(questTimer));
		QuestGuru_QuestLogObjective1:SetPoint("TOPLEFT", "QuestGuru_QuestLogTimerText", "BOTTOMLEFT", 0, -10);
	else
		QuestGuru_QuestLogFrame.hasTimer = nil;
		QuestGuru_QuestLogTimerText:Hide();
		QuestGuru_QuestLogObjective1:SetPoint("TOPLEFT", "QuestGuru_QuestLogObjectivesText", "BOTTOMLEFT", 0, -10);
	end
	
	-- Show Quest Watch if track quest is checked
	local numObjectives = GetNumQuestLeaderBoards();
	local currObj = 0;
	
	for i=1, 10 do
		getglobal("QuestGuru_QuestLogObjective"..i):Hide();
		getglobal("QuestGuru_QuestLogObjectiveItem"..i):Hide();
	end

	for i=1, numObjectives, 1 do
		local text;
		local type;
		local finished;
		text, type, finished = GetQuestLogLeaderBoard(i);
		if (type ~= "item") then
			currObj = currObj + 1;
			local questObj = getglobal("QuestGuru_QuestLogObjective"..currObj);
			_G["QuestLogObjective"..currObj] = questObj;
			if ( not text or strlen(text) == 0 ) then
				text = type;
			end
			if ( finished ) then
				questObj:SetTextColor(0.2, 0.2, 0.2);
				text = text.." ("..COMPLETE..")";
			else
				questObj:SetTextColor(0, 0, 0);
			end
			questObj:SetText(text);
			questObj:Show();
			questObj:SetAlpha(1);
			QuestFrame_SetAsLastShown(questObj);
			lastObjective = questObj;
		end
	end

	local currObjItem = 0;
	for i=1, numObjectives, 1 do
		local text;
		local type;
		local finished;
		local texture, link, count;
		text, type, finished = GetQuestLogLeaderBoard(i);
		if (type == "item") then
			currObjItem = currObjItem + 1;
			local questItem = getglobal("QuestGuru_QuestLogObjectiveItem"..currObjItem);
			local questItemCount = getglobal("QuestGuru_QuestLogObjectiveItem"..currObjItem.."Count");
			local questObj = getglobal("QuestGuru_QuestLogObjective"..currObj+currObjItem);
			_G["QuestLogObjective"..currObj+currObjItem] = questObj;
			questItem.type = "required";
			numItems = 1;
			local itemLink = QuestGuru_GetQuestItemLink(questItem.type, i);
			local x, y, name, numItems, numNeeded = string.find(text,"(.*):%s*([%d]+)%s*/%s*([%d]+)");
			
			if (not itemLink) then
				texture = "Interface\\Icons\\INV_Misc_QuestionMark";
				count = 0;
			else
				name, link, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, texture = GetItemInfo(itemLink);
				count = GetItemCount(itemLink);
			end
			questItem:SetID(currObjItem)
			questItem:Show();
			questObj:Show();
			questObj:SetAlpha(0);
			-- For the tooltip
			questItem.rewardType = "item"
			questItem.link = itemLink;
			QuestFrame_SetAsLastShown(questItem, spacerFrame);
			getglobal("QuestGuru_QuestLogObjectiveItem"..currObjItem.."Name"):SetText(name);
			questObj:SetText(text);
			questItemCount:SetText(count.." /"..numNeeded);
			questItemCount:Show();
			SetItemButtonTexture(questItem, texture);
			if ( finished ) then
				SetItemButtonTextureVertexColor(questItem, 1.0, 1.0, 1.0);
				SetItemButtonNameFrameVertexColor(questItem, 1.0, 1.0, 1.0);
			else
				SetItemButtonTextureVertexColor(questItem, 0.5, 0.5, 0.5);
				SetItemButtonNameFrameVertexColor(questItem, 0.5, 0.5, 0.5);
			end
			if ( currObjItem  > 1 ) then
				if ( mod(currObjItem ,2) == 1 ) then
					questItem:SetPoint("TOPLEFT", "QuestGuru_QuestLogObjectiveItem"..(currObjItem - 2), "BOTTOMLEFT", 0, -2);
					lastObjective = questItem;
				else
					questItem:SetPoint("TOPLEFT", "QuestGuru_QuestLogObjectiveItem"..(currObjItem - 1), "TOPRIGHT", 1, 0);
					lastObjective = getglobal("QuestGuru_QuestLogObjectiveItem"..(currObjItem)-1);
				end
			else
				if (currObj > 0) then
					questItem:SetPoint("TOPLEFT", "QuestGuru_QuestLogObjective"..currObj, "BOTTOMLEFT", 0, -5);
				else
					questItem:SetPoint("TOPLEFT", "QuestGuru_QuestLogObjectivesText", "BOTTOMLEFT", 0, -10);
				end
				lastObjective = questItem;
			end
		end
	end


	-- If there's money required then anchor and display it
	if ( GetQuestLogRequiredMoney() > 0 ) then
		if ( numObjectives > 0 ) then
			QuestGuru_QuestLogRequiredMoneyText:SetPoint("TOPLEFT", lastObjective, "BOTTOMLEFT", 0, -4);
		else
			QuestGuru_QuestLogRequiredMoneyText:SetPoint("TOPLEFT", "QuestGuru_QuestLogObjectivesText", "BOTTOMLEFT", 0, -10);
		end
		
		MoneyFrame_Update("QuestGuru_QuestLogRequiredMoneyFrame", GetQuestLogRequiredMoney());
		
		if ( GetQuestLogRequiredMoney() > GetMoney() ) then
			-- Not enough money
			QuestGuru_QuestLogRequiredMoneyText:SetTextColor(0, 0, 0);
			SetMoneyFrameColor("QuestGuru_QuestLogRequiredMoneyFrame", 1.0, 0.1, 0.1);
		else
			QuestGuru_QuestLogRequiredMoneyText:SetTextColor(0.2, 0.2, 0.2);
			SetMoneyFrameColor("QuestGuru_QuestLogRequiredMoneyFrame", 1.0, 1.0, 1.0);
		end
		QuestGuru_QuestLogRequiredMoneyText:Show();
		QuestGuru_QuestLogRequiredMoneyFrame:Show();
	else
		QuestGuru_QuestLogRequiredMoneyText:Hide();
		QuestGuru_QuestLogRequiredMoneyFrame:Hide();
	end

	if ( GetQuestLogGroupNum() > 0 ) then
		local suggestedGroupString = format(QUEST_SUGGESTED_GROUP_NUM, GetQuestLogGroupNum());
		QuestGuru_QuestLogSuggestedGroupNum:SetText(suggestedGroupString);
		QuestGuru_QuestLogSuggestedGroupNum:Show();
		QuestGuru_QuestLogSuggestedGroupNum:ClearAllPoints();
		if ( GetQuestLogRequiredMoney() > 0 ) then
			QuestGuru_QuestLogSuggestedGroupNum:SetPoint("TOPLEFT", "QuestGuru_QuestLogRequiredMoneyText", "BOTTOMLEFT", 0, -4);
		elseif ( numObjectives > 0 ) then
			QuestGuru_QuestLogSuggestedGroupNum:SetPoint("TOPLEFT", lastObjective, "BOTTOMLEFT", 0, -4);
		elseif ( questTimer ) then
			QuestGuru_QuestLogSuggestedGroupNum:SetPoint("TOPLEFT", "QuestGuru_QuestLogTimerText", "BOTTOMLEFT", 0, -10);
		else
			QuestGuru_QuestLogSuggestedGroupNum:SetPoint("TOPLEFT", "QuestGuru_QuestLogObjectivesText", "BOTTOMLEFT", 0, -10);
		end
	else
		QuestGuru_QuestLogSuggestedGroupNum:Hide();
	end

	if ( GetQuestLogGroupNum() > 0 ) then
		QuestGuru_QuestLogDescriptionTitle:SetPoint("TOPLEFT", "QuestGuru_QuestLogSuggestedGroupNum", "BOTTOMLEFT", 0, -10);
	elseif ( GetQuestLogRequiredMoney() > 0 ) then
		QuestGuru_QuestLogDescriptionTitle:SetPoint("TOPLEFT", "QuestGuru_QuestLogRequiredMoneyText", "BOTTOMLEFT", 0, -10);
	elseif ( numObjectives > 0 ) then
		QuestGuru_QuestLogDescriptionTitle:SetPoint("TOPLEFT", lastObjective, "BOTTOMLEFT", 0, -10);
	else
		if ( questTimer ) then
			QuestGuru_QuestLogDescriptionTitle:SetPoint("TOPLEFT", "QuestGuru_QuestLogTimerText", "BOTTOMLEFT", 0, -10);
		else
			QuestGuru_QuestLogDescriptionTitle:SetPoint("TOPLEFT", "QuestGuru_QuestLogObjectivesText", "BOTTOMLEFT", 0, -10);
		end
	end
	if ( questDescription ) then
		QuestGuru_QuestLogQuestDescription:SetText(questDescription);
		QuestFrame_SetAsLastShown(QuestGuru_QuestLogQuestDescription);
	end
	local numRewards = GetNumQuestLogRewards();
	local numChoices = GetNumQuestLogChoices();
	local money = GetQuestLogRewardMoney();

	if ( (numRewards + numChoices + money) > 0 ) then
		QuestGuru_QuestLogRewardTitleText:Show();
		QuestFrame_SetAsLastShown(QuestGuru_QuestLogRewardTitleText);
	else
		QuestGuru_QuestLogRewardTitleText:Hide();
	end

	QuestFrameItems_Update("QuestLog");
	if ( not doNotScroll ) then
		QuestGuru_QuestLogDetailScrollFrameScrollBar:SetValue(0);
	end
	QuestGuru_QuestLogDetailScrollFrame:UpdateScrollChildRect();
end

function QuestGuru_GetQuestItemLink(type, i)
	local text, type, finished = GetQuestLogLeaderBoard(i);
	local x, y, name, numItems, numNeeded = string.find(text,"(.*):%s*([%d]+)%s*/%s*([%d]+)");
	
	local iItemCount = 0;	
	for bag = 4, 0, -1 do
		local size = GetContainerNumSlots(bag);
		if (size > 0) then
			for slot=1, size, 1 do
				local itemIcon, itemQuantity = GetContainerItemInfo(bag, slot);
				if (itemQuantity) then
					local itemName = GetItemInfo(GetContainerItemLink(bag,slot)); 
					if ((itemName) and (itemName ~= "")) then
						--**
						if(itemName == name) then
							return GetContainerItemLink(bag,slot);
						end
						--**
					end
				end
			end
		end
	end	
	return nil;
end

--Used to attach an empty spacer frame to the last shown object
local old_QuestFrame_SetAsLastShown = QuestFrame_SetAsLastShown;
function QuestFrame_SetAsLastShown(frame, spacerFrame)
	if ( not spacerFrame ) then
		spacerFrame = QuestLogSpacerFrame;
	end
	spacerFrame:SetPoint("TOP", frame, "BOTTOM", 0, 0);
end

local old_QuestLogTitleButton_OnClick = QuestLogTitleButton_OnClick;
function QuestLogTitleButton_OnClick(button)
	local questName = this:GetText();
	local questIndex = this:GetID() + FauxScrollFrame_GetOffset(QuestGuru_QuestLogListScrollFrame);
	if ( IsShiftKeyDown() ) then
		-- If header then return
		if ( this.isHeader ) then
			return;
		end
		-- Otherwise try to track it or put it into chat
		if ( ChatFrameEditBox:IsVisible() ) then
			ChatFrameEditBox:Insert(strtrim(this:GetText()));
		else
			-- Shift-click toggles quest-watch on this quest.
			if ( IsQuestWatched(questIndex) ) then
				RemoveQuestWatch(questIndex);
				QuestWatch_Update();
			else
				-- Set error if no objectives
				if ( GetNumQuestLeaderBoards(questIndex) == 0 ) then
					UIErrorsFrame:AddMessage(QUEST_WATCH_NO_OBJECTIVES, 1.0, 0.1, 0.1, 1.0);
					return;
				end
				-- Set an error message if trying to show too many quests
				if ( GetNumQuestWatches() >= MAX_WATCHABLE_QUESTS ) then
					UIErrorsFrame:AddMessage(format(QUEST_WATCH_TOO_MANY, MAX_WATCHABLE_QUESTS), 1.0, 0.1, 0.1, 1.0);
					return;
				end
				AddQuestWatch(questIndex);
				QuestLog_Update();
				QuestWatch_Update();
			end
		end
	end
	QuestLog_SetSelection(questIndex)
	QuestLog_Update();
end

local old_QuestLogTitleButton_OnEnter = QuestLogTitleButton_OnEnter;
function QuestLogTitleButton_OnEnter()
	-- Set highlight
	getglobal(this:GetName().."Tag"):SetTextColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);

	-- Set group info tooltip
	QuestLog_UpdatePartyInfoTooltip();
end

local old_QuestLog_UpdatePartyInfoTooltip = QuestLog_UpdatePartyInfoTooltip;
function QuestLog_UpdatePartyInfoTooltip()
	local index = this:GetID() + FauxScrollFrame_GetOffset(QuestGuru_QuestLogListScrollFrame);
	local numPartyMembers = GetNumPartyMembers();
	if ( numPartyMembers == 0 or this.isHeader ) then
		return;
	end
	GameTooltip_SetDefaultAnchor(GameTooltip, this);
	
	local questLogTitleText = GetQuestLogTitle(index);
	GameTooltip:SetText(questLogTitleText);

	local partyMemberOnQuest;
	for i=1, numPartyMembers do
		if ( IsUnitOnQuest(index, "party"..i) ) then
			if ( not partyMemberOnQuest ) then
				GameTooltip:AddLine(HIGHLIGHT_FONT_COLOR_CODE..PARTY_QUEST_STATUS_ON..FONT_COLOR_CODE_CLOSE);
				partyMemberOnQuest = 1;
			end
			GameTooltip:AddLine(LIGHTYELLOW_FONT_COLOR_CODE..UnitName("party"..i)..FONT_COLOR_CODE_CLOSE);
		end
	end
	if ( not partyMemberOnQuest ) then
		GameTooltip:AddLine(HIGHLIGHT_FONT_COLOR_CODE..PARTY_QUEST_STATUS_NONE..FONT_COLOR_CODE_CLOSE);
	end
	GameTooltip:Show();
end

local old_QuestLogRewardItem_OnClick = QuestLogRewardItem_OnClick;
function QuestLogRewardItem_OnClick()
	if ( IsControlKeyDown() ) then
		if ( this.rewardType ~= "spell" ) then
			DressUpItemLink(GetQuestLogItemLink(this.type, this:GetID()));
		end
	elseif ( IsShiftKeyDown() ) then
		if ( this.rewardType ~= "spell" ) then
			ChatEdit_InsertLink(GetQuestLogItemLink(this.type, this:GetID()));
		end
	end
end

local old_QuestLog_GetFirstSelectableQuest = QuestLog_GetFirstSelectableQuest;
function QuestLog_GetFirstSelectableQuest()
	local numEntries = GetNumQuestLogEntries();
	local index = 0;
	local questLogTitleText, level, questTag, suggestedGroup, isHeader, isCollapsed;
	for i=1, numEntries, 1 do
		index = i;
		questLogTitleText, level, questTag, suggestedGroup, isHeader, isCollapsed = GetQuestLogTitle(i);
		if ( questLogTitleText and not isHeader ) then
			return index;
		end
	end
	return index;
end

local old_QuestLog_SetFirstValidSelection = QuestLog_SetFirstValidSelection;
function QuestLog_SetFirstValidSelection()
	local selectableQuest = QuestLog_GetFirstSelectableQuest();
	QuestLog_SetSelection(selectableQuest);
	QuestGuru_QuestLogListScrollFrameScrollBar:SetValue(0);
end

local old_GetQuestLogIndexByName = GetQuestLogIndexByName;
function GetQuestLogIndexByName(name)
	local numEntries = GetNumQuestLogEntries();
	local questLogTitleText;
	for i=1, numEntries, 1 do
		questLogTitleText = GetQuestLogTitle(i);
		if ( "  "..questLogTitleText == name ) then
			return i;
		end
	end
	return nil;
end

local old_QuestLogUpdateQuestCount = QuestLogUpdateQuestCount;
function QuestLogUpdateQuestCount(numQuests)
	QuestGuru_QuestLogQuestCount:SetText(format(QUEST_LOG_COUNT_TEMPLATE, numQuests, MAX_QUESTLOG_QUESTS));
	local width = QuestGuru_QuestLogQuestCount:GetWidth();
	local textHeight = 12;
	local hPadding = 15;
	local vPadding = 8;
	local dailyQuestsComplete = GetDailyQuestsCompleted();
	
	if ( dailyQuestsComplete > 0 ) then
		QuestGuru_QuestLogDailyQuestCount:SetText(format(QUEST_LOG_DAILY_COUNT_TEMPLATE, dailyQuestsComplete, GetMaxDailyQuests()));
		QuestGuru_QuestLogDailyQuestCount:Show();
		QuestGuru_DailyQuestCountButton:Show();
		-- Use this width
		if ( QuestGuru_QuestLogDailyQuestCount:GetWidth() > width ) then
			width = QuestGuru_QuestLogDailyQuestCount:GetWidth();
		end
		QuestGuru_QuestLogCount:SetHeight(textHeight*2+vPadding);
		QuestGuru_QuestLogCount:SetPoint("TOPRIGHT", QuestGuru_QuestLogFrame, "TOPRIGHT", -80, -20);
	else
		QuestGuru_QuestLogDailyQuestCount:Hide();
		QuestGuru_DailyQuestCountButton:Hide();
		width = QuestGuru_QuestLogQuestCount:GetWidth();
		QuestGuru_QuestLogCount:SetHeight(textHeight+8);
		QuestGuru_QuestLogCount:SetPoint("TOPRIGHT", QuestGuru_QuestLogFrame, "TOPRIGHT", -80, -23);
	end
	QuestGuru_QuestLogCount:SetWidth(width+hPadding);
end

local old_QuestFrameItems_Update = QuestFrameItems_Update;
function QuestFrameItems_Update(questState)
	local isQuestLog = 0;
	if ( questState == "QuestLog" ) then
		isQuestLog = 1;
		questState = "QuestGuru_QuestLog";
	end
	local numQuestRewards;
	local numQuestChoices;
	local numQuestSpellRewards = 0;
	local money;
	local spacerFrame;
	if ( isQuestLog == 1 ) then
		numQuestRewards = GetNumQuestLogRewards();
		numQuestChoices = GetNumQuestLogChoices();
		if ( GetQuestLogRewardSpell() ) then
			numQuestSpellRewards = 1;
		end
		money = GetQuestLogRewardMoney();
		spacerFrame = QuestGuru_QuestLogSpacerFrame;
	else
		numQuestRewards = GetNumQuestRewards();
		numQuestChoices = GetNumQuestChoices();
		if ( GetRewardSpell() ) then
			numQuestSpellRewards = 1;
		end
		money = GetRewardMoney();
		spacerFrame = QuestGuru_QuestSpacerFrame;
	end

	local totalRewards = numQuestRewards + numQuestChoices + numQuestSpellRewards;
	local questItemName = questState.."Item";
	local material = QuestFrame_GetMaterial();
	local  questItemReceiveText = getglobal(questState.."ItemReceiveText")
	if ( totalRewards == 0 and money == 0 ) then
		getglobal(questState.."RewardTitleText"):Hide();
	else
		getglobal(questState.."RewardTitleText"):Show();
		QuestFrame_SetTitleTextColor(getglobal(questState.."RewardTitleText"), material);
		QuestFrame_SetAsLastShown(getglobal(questState.."RewardTitleText"), spacerFrame);
	end
	if ( money == 0 ) then
		getglobal(questState.."MoneyFrame"):Hide();
	else
		getglobal(questState.."MoneyFrame"):Show();
		QuestFrame_SetAsLastShown(getglobal(questState.."MoneyFrame"), spacerFrame);
		MoneyFrame_Update(questState.."MoneyFrame", money);
	end

	-- Hide unused rewards
	for i=totalRewards + 1, MAX_NUM_ITEMS, 1 do
		getglobal(questItemName..i):Hide();
	end

	local questItem, name, texture, isTradeskillSpell, isSpellLearned, quality, isUsable, numItems = 1;
	local rewardsCount = 0;

	-- Setup choosable rewards
	if ( numQuestChoices > 0 ) then
		local itemChooseText = getglobal(questState.."ItemChooseText");
		itemChooseText:Show();
		QuestFrame_SetTextColor(itemChooseText, material);
		QuestFrame_SetAsLastShown(itemChooseText, spacerFrame);

		local index;
		local baseIndex = rewardsCount;
		for i=1, numQuestChoices, 1 do
			index = i + baseIndex;
			questItem = getglobal(questItemName..index);
			questItem.type = "choice";
			numItems = 1;
			if ( isQuestLog == 1 ) then
				name, texture, numItems, quality, isUsable = GetQuestLogChoiceInfo(i);
			else
				name, texture, numItems, quality, isUsable = GetQuestItemInfo(questItem.type, i);
			end
			questItem:SetID(i)
			questItem:Show();
			-- For the tooltip
			questItem.rewardType = "item"
			QuestFrame_SetAsLastShown(questItem, spacerFrame);
			getglobal(questItemName..index.."Name"):SetText(name);
			SetItemButtonCount(questItem, numItems);
			SetItemButtonTexture(questItem, texture);
			if ( isUsable ) then
				SetItemButtonTextureVertexColor(questItem, 1.0, 1.0, 1.0);
				SetItemButtonNameFrameVertexColor(questItem, 1.0, 1.0, 1.0);
			else
				SetItemButtonTextureVertexColor(questItem, 0.9, 0, 0);
				SetItemButtonNameFrameVertexColor(questItem, 0.9, 0, 0);
			end
			if ( i > 1 ) then
				if ( mod(i,2) == 1 ) then
					questItem:SetPoint("TOPLEFT", questItemName..(index - 2), "BOTTOMLEFT", 0, -2);
				else
					questItem:SetPoint("TOPLEFT", questItemName..(index - 1), "TOPRIGHT", 1, 0);
				end
			else
				questItem:SetPoint("TOPLEFT", itemChooseText, "BOTTOMLEFT", -3, -5);
			end
			rewardsCount = rewardsCount + 1;
		end
	else
		getglobal(questState.."ItemChooseText"):Hide();
	end

	-- Setup spell rewards
	if ( numQuestSpellRewards > 0 ) then
		local learnSpellText = getglobal(questState.."SpellLearnText");
		learnSpellText:Show();
		QuestFrame_SetTextColor(learnSpellText, material);
		QuestFrame_SetAsLastShown(learnSpellText, spacerFrame);

		--Anchor learnSpellText if there were choosable rewards
		if ( rewardsCount > 0 ) then
			learnSpellText:SetPoint("TOPLEFT", questItemName..rewardsCount, "BOTTOMLEFT", 3, -5);
		else
			learnSpellText:SetPoint("TOPLEFT", questState.."RewardTitleText", "BOTTOMLEFT", 0, -5);
		end

		if ( isQuestLog == 1 ) then
			texture, name, isTradeskillSpell, isSpellLearned = GetQuestLogRewardSpell();
		else
			texture, name, isTradeskillSpell, isSpellLearned = GetRewardSpell();
		end

		if ( isTradeskillSpell ) then
			learnSpellText:SetText(REWARD_TRADESKILL_SPELL);
		elseif ( not isSpellLearned ) then
			learnSpellText:SetText(REWARD_AURA);
		else
			learnSpellText:SetText(REWARD_SPELL);
		end

		rewardsCount = rewardsCount + 1;
		questItem = getglobal(questItemName..rewardsCount);
		questItem:Show();
		-- For the tooltip
		questItem.rewardType = "spell";
		SetItemButtonCount(questItem, 0);
		SetItemButtonTexture(questItem, texture);
		getglobal(questItemName..rewardsCount.."Name"):SetText(name);
		questItem:SetPoint("TOPLEFT", learnSpellText, "BOTTOMLEFT", -3, -5);
	else
		getglobal(questState.."SpellLearnText"):Hide();
	end

	-- Setup mandatory rewards
	if ( numQuestRewards > 0 or money > 0) then
		QuestFrame_SetTextColor(questItemReceiveText, material);
		-- Anchor the reward text differently if there are choosable rewards
		if ( numQuestSpellRewards > 0  ) then
			questItemReceiveText:SetText(REWARD_ITEMS);
			questItemReceiveText:SetPoint("TOPLEFT", questItemName..rewardsCount, "BOTTOMLEFT", 3, -5);
		elseif ( numQuestChoices > 0  ) then
			questItemReceiveText:SetText(REWARD_ITEMS);
			local index = numQuestChoices;
			if ( mod(index, 2) == 0 ) then
				index = index - 1;
			end
			questItemReceiveText:SetPoint("TOPLEFT", questItemName..index, "BOTTOMLEFT", 3, -5);
		else
			questItemReceiveText:SetText(REWARD_ITEMS_ONLY);
			questItemReceiveText:SetPoint("TOPLEFT", questState.."RewardTitleText", "BOTTOMLEFT", 3, -5);
		end
		questItemReceiveText:Show();
		QuestFrame_SetAsLastShown(questItemReceiveText, spacerFrame);
		-- Setup mandatory rewards
		local index;
		local baseIndex = rewardsCount;
		for i=1, numQuestRewards, 1 do
			index = i + baseIndex;
			questItem = getglobal(questItemName..index);
			questItem.type = "reward";
			numItems = 1;
			if ( isQuestLog == 1 ) then
				name, texture, numItems, quality, isUsable = GetQuestLogRewardInfo(i);
			else
				name, texture, numItems, quality, isUsable = GetQuestItemInfo(questItem.type, i);
			end
			questItem:SetID(i)
			questItem:Show();
			-- For the tooltip
			questItem.rewardType = "item";
			QuestFrame_SetAsLastShown(questItem, spacerFrame);
			getglobal(questItemName..index.."Name"):SetText(name);
			SetItemButtonCount(questItem, numItems);
			SetItemButtonTexture(questItem, texture);
			if ( isUsable ) then
				SetItemButtonTextureVertexColor(questItem, 1.0, 1.0, 1.0);
				SetItemButtonNameFrameVertexColor(questItem, 1.0, 1.0, 1.0);
			else
				SetItemButtonTextureVertexColor(questItem, 0.5, 0, 0);
				SetItemButtonNameFrameVertexColor(questItem, 1.0, 0, 0);
			end

			if ( i > 1 ) then
				if ( mod(i,2) == 1 ) then
					questItem:SetPoint("TOPLEFT", questItemName..(index - 2), "BOTTOMLEFT", 0, -2);
				else
					questItem:SetPoint("TOPLEFT", questItemName..(index - 1), "TOPRIGHT", 1, 0);
				end
			else
				questItem:SetPoint("TOPLEFT", questState.."ItemReceiveText", "BOTTOMLEFT", -3, -5);
			end
			rewardsCount = rewardsCount + 1;
		end
	else
		questItemReceiveText:Hide();
	end
	if ( questState == "QuestReward" ) then
		QuestFrameCompleteQuestButton:Enable();
		QuestFrameRewardPanel.itemChoice = 0;
		QuestRewardItemHighlight:Hide();
	end
end
