QuestGuru_History = {};
QuestGuru_HistoryHeaders = {};
QuestGuru_numHistory = 0;
QuestGuru_currHistory = 2;
QuestGuru_LastCompleteQuest = {};

function QuestGuru_QuestHistoryTitleButton_OnLoad()
	this:RegisterForClicks("LeftButtonUp", "RightButtonUp");
	this:RegisterEvent("UNIT_QUEST_LOG_CHANGED");
	this:RegisterEvent("PARTY_MEMBER_ENABLE");
	this:RegisterEvent("PARTY_MEMBER_DISABLE");
end

function QuestGuru_QuestHistoryTitleButton_OnEvent(event)
	if ( GameTooltip:IsOwned(this) ) then
		GameTooltip:Hide();
--		QuestLog_UpdatePartyInfoTooltip();
	end
end

function QuestGuru_QuestHistoryTitleButton_OnClick(button)
	local questName = this:GetText();
	local questIndex = this:GetID() + FauxScrollFrame_GetOffset(QuestGuru_QuestHistoryListScrollFrame);
	if ( IsShiftKeyDown() ) then
		-- If header then return
		if ( this.isHeader ) then
			return;
		end
		-- Otherwise try to put it into chat
		if ( ChatFrameEditBox:IsVisible() ) then
			ChatFrameEditBox:Insert(strtrim(this:GetText()));
		end
	end
	QuestLog_SetHistorySelection(questIndex)
	QuestGuru_UpdateHistory();
end

function QuestGuru_QuestHistoryTitleButton_OnEnter()
	-- Set highlight
	getglobal(this:GetName().."Tag"):SetTextColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);

	-- Set group info tooltip
--	QuestLog_UpdatePartyInfoTooltip();
end

function QuestGuru_SaveLastQuest()
	local lastHeader;
	local numEntries, numQuests = GetNumQuestLogEntries();
	local i, j;
	
	local prevQuestLogEntry = GetQuestLogSelection();
	for i=1, numEntries do
		local questTitle, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete, isDaily = GetQuestLogTitle(i);
		if (isHeader) then
			QuestGuru_LastCompleteQuest.Header = questTitle;
		elseif (questTitle == QuestGuru_LastCompleteQuest.Title) then
			SelectQuestLogEntry(i);
			QuestGuru_LastCompleteQuest.Level = level;
			QuestGuru_LastCompleteQuest.Tag = questTag;
			QuestGuru_LastCompleteQuest.SuggestedGroup = suggestedGroup;
			QuestGuru_LastCompleteQuest.Daily = isDaily;
			QuestGuru_LastCompleteQuest.FinishTime = date("%m/%d/%Y %H:%M:%S");
			QuestGuru_LastCompleteQuest.StartTime = QuestGuru_StartTime[questTitle];

			local questDescription, questObjectives = GetQuestLogQuestText();
			QuestGuru_LastCompleteQuest.Description = gsub(questDescription,QuestGuru_Player,"<%name%>");
			QuestGuru_LastCompleteQuest.ObjectiveText = gsub(questObjectives,QuestGuru_Player,"<%name%>");

			local numObjectives = GetNumQuestLeaderBoards();
			QuestGuru_LastCompleteQuest.Objectives = numObjectives;
			QuestGuru_LastCompleteQuest.Objective = {};
			for j=1, numObjectives do
				local desc, type, done = GetQuestLogLeaderBoard(j, i);
				QuestGuru_LastCompleteQuest.Objective[j] = {};
				QuestGuru_LastCompleteQuest.Objective[j].Type = type;
				if (type == "item") then
					local itemLink = QuestGuru_GetQuestItemLink(type, j);
					local x, y, name, numItems, numNeeded = string.find(desc,"(.*):%s*([%d]+)%s*/%s*([%d]+)");
					QuestGuru_LastCompleteQuest.Objective[j].Description = itemLink;
					QuestGuru_LastCompleteQuest.Objective[j].numNeeded = numNeeded;
				else
					QuestGuru_LastCompleteQuest.Objective[j].Description = desc;
				end

			end

			QuestGuru_LastCompleteQuest.RequiredMoney = GetQuestLogRequiredMoney();

			local numRewards = GetNumQuestLogRewards();
			QuestGuru_LastCompleteQuest.Rewards = numRewards;
			QuestGuru_LastCompleteQuest.Reward = {};
			for j=1, numRewards do
				name, texture, numItems, quality, isUsable = GetQuestLogRewardInfo(j);
				QuestGuru_LastCompleteQuest.Reward[j] = {};
				QuestGuru_LastCompleteQuest.Reward[j].Link = GetQuestLogItemLink("reward", j);
				QuestGuru_LastCompleteQuest.Reward[j].Count = numItems;
			end

			local numChoices = GetNumQuestLogChoices();
			QuestGuru_LastCompleteQuest.Choices = numChoices;
			QuestGuru_LastCompleteQuest.Choice = {};
			for j=1, numChoices do
				name, texture, numItems, quality, isUsable = GetQuestLogChoiceInfo(j);
				QuestGuru_LastCompleteQuest.Choice[j] = {};
				QuestGuru_LastCompleteQuest.Choice[j].Link = GetQuestLogItemLink("choice", j);
				QuestGuru_LastCompleteQuest.Choice[j].Count = numItems;
			end

			if (GetRewardSpell()) then
			    QuestGuru_LastCompleteQuest.SpellRewards = 1;
			    QuestGuru_LastCompleteQuest.SpellReward = {};
				texture, name, isTradeskillSpell, isSpellLearned = GetQuestLogRewardSpell();
				QuestGuru_LastCompleteQuest.SpellReward.Texture = texture;
				QuestGuru_LastCompleteQuest.SpellReward.Name = name;
			else
			    QuestGuru_LastCompleteQuest.SpellRewards = 0;
			end
			
			QuestGuru_LastCompleteQuest.RewardMoney = GetQuestLogRewardMoney();
			SelectQuestLogEntry(prevQuestLogEntry);
--			DEFAULT_CHAT_FRAME:AddMessage("QuestGuru Saved: ["..QuestGuru_LastCompleteQuest.Level.."] "..QuestGuru_LastCompleteQuest.Title);
			return;
		end
	end
end

function QuestGuru_UpdateHistory()
	local count=0;
	local headCount = 0;
	local titleCount = 0;
	local currHistory = 1;
	local currHeader = "";
	local questHistory;
	local scrollOffset = FauxScrollFrame_GetOffset(QuestGuru_QuestHistoryListScrollFrame);
	
	local questIndex, questHistoryTitle, questTitleTag, questNumGroupMates, questNormalText, questHighlight, questCheck;
	local questLogTitleText, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete, isDaily, color;
	local numPartyMembers, partyMembersOnQuest, tempWidth, textWidth;
	local questTagText, strLvl;
	
	QuestGuru_QuestHistoryHighlightFrame:Hide();

	for i, questHistory in ipairs(QuestGuru_History) do
		if ((titleCount+headCount >= scrollOffset) or (questHistory.Header ~= currHeader and titleCount+headCount+1==scrollOffset)) then
			if (currHistory <= QUESTS_DISPLAYED) then

				if ((titleCount+headCount+1) == scrollOffset and questHistory.Header ~= currHeader) then
					currHeader = questHistory.Header;
					headCount = headCount + 1;
				else
					if (questHistory.Header ~= currHeader) then
						questHistoryTitle = getglobal("QuestGuru_QuestHistoryTitle"..currHistory);
						questTitleTag = getglobal("QuestGuru_QuestHistoryTitle"..currHistory.."Tag");
						questNumGroupMates = getglobal("QuestGuru_QuestHistoryTitle"..currHistory.."GroupMates");
						questCheck = getglobal("QuestGuru_QuestHistoryTitle"..currHistory.."Check");
						questNormalText = getglobal("QuestGuru_QuestHistoryTitle"..currHistory.."NormalText");
						questHighlight = getglobal("QuestGuru_QuestHistoryTitle"..currHistory.."Highlight");
						questHistoryTitle:SetText(questHistory.Header);
						if (QuestGuru_HistoryHeaders[questHistory.Header] ~= false) then
							questHistoryTitle:SetNormalTexture("Interface\\Buttons\\UI-MinusButton-Up");
							QuestGuru_HistoryHeaders[questHistory.Header] = true;
						else
							questHistoryTitle:SetNormalTexture("Interface\\Buttons\\UI-PlusButton-Up");
						end
						questHighlight:SetTexture("Interface\\Buttons\\UI-PlusButton-Hilight");
						questNumGroupMates:SetText("");
						questCheck:Hide();
						questHistoryTitle.isHeader = true;
						currHeader = questHistory.Header;
						color = QuestDifficultyColor["header"];
						questTitleTag:SetText("");
						questTitleTag:SetTextColor(color.r, color.g, color.b);
						questHistoryTitle:SetTextColor(color.r, color.g, color.b);
						questNumGroupMates:SetTextColor(color.r, color.g, color.b);
						questHistoryTitle.r = color.r;
						questHistoryTitle.g = color.g;
						questHistoryTitle.b = color.b;
						questHistoryTitle:Show();
						headCount = headCount + 1;
						currHistory = currHistory + 1;
					end
				end

				if (currHistory <= QUESTS_DISPLAYED and QuestGuru_HistoryHeaders[questHistory.Header] ~= false) then
					questHistoryTitle = getglobal("QuestGuru_QuestHistoryTitle"..currHistory);
					questTitleTag = getglobal("QuestGuru_QuestHistoryTitle"..currHistory.."Tag");
					questNumGroupMates = getglobal("QuestGuru_QuestHistoryTitle"..currHistory.."GroupMates");
					questCheck = getglobal("QuestGuru_QuestHistoryTitle"..currHistory.."Check");
					questNormalText = getglobal("QuestGuru_QuestHistoryTitle"..currHistory.."NormalText");
					questHighlight = getglobal("QuestGuru_QuestHistoryTitle"..currHistory.."Highlight");
	
					strLvl = " ["
					if (questHistory.Level ~= nil) then
						strLvl = strLvl..questHistory.Level
					else
						strLvl = strLvl.."??"
					end
					if (questHistory.Tag ~= nil) then
						if ((questHistory.Tag == "Group") and (questHistory.SuggestedGroup > 0)) then
							strLvl = strLvl.."G"..questHistory.SuggestedGroup;
						elseif (questHistory.Tag == "Dungeon") then
							strLvl = strLvl.."D";
						else
							strLvl = strLvl.."+"
						end
					end
					strLvl = strLvl.."] "
					local s = strLvl..questHistory.Title;
					if (questHistory.Count ~= nil and questHistory.Daily == 1) then
						s = s.." ("..questHistory.Count..")";
					end
					questHistoryTitle:SetText(s);
					--Set Dummy text to get text width *SUPER HACK*
					QuestGuru_QuestLogDummyText:SetText(s);
	
					questHistoryTitle:SetNormalTexture("");
					questHighlight:SetTexture("");
    	
					questNumGroupMates:SetText("");
					-- Save if its a header or not
					questHistoryTitle.isHeader = false;
    	
					questTag = questHistory.Tag;
					if ( questTag ) then
					    if ((questTag == "Group") and (questHistory.SuggestedGroup == 0)) then
					        questTag = "Elite";
						end
						questTagText = "("..questTag
						if ((questHistory.SuggestedGroup ~= nil) and (questHistory.SuggestedGroup > 0)) then
							questTagText = questTagText..":"..questHistory.SuggestedGroup;
						end
						questTagText = questTagText..")";
						questTitleTag:SetText(questTagText);
						-- Shrink text to accomdate quest tags without wrapping
						tempWidth = 275 - 15 - questTitleTag:GetWidth();
					
						if ( QuestGuru_QuestLogDummyText:GetWidth() > tempWidth ) then
							textWidth = tempWidth;
						else
							textWidth = QuestGuru_QuestLogDummyText:GetWidth();
						end
					
						questNormalText:SetWidth(tempWidth);
					
						questCheck:Hide();
					else
						questTitleTag:SetText("");
						questNormalText:SetWidth(275);
    	
						-- Show check if quest is being watched
						questCheck:Hide();
					end
    	
					-- Color the quest title and highlight according to the difficulty level
					local playerLevel = UnitLevel("player");
					color = GetDifficultyColor(questHistory.Level);
					questTitleTag:SetTextColor(color.r, color.g, color.b);
					questHistoryTitle:SetTextColor(color.r, color.g, color.b);
					questNumGroupMates:SetTextColor(color.r, color.g, color.b);
					questHistoryTitle.r = color.r;
					questHistoryTitle.g = color.g;
					questHistoryTitle.b = color.b;
					questHistoryTitle:Show();
        	
					-- Place the highlight and lock the highlight state
					if ( QuestGuru_currHistory == currHistory + scrollOffset ) then
						QuestGuru_QuestHistoryHighlightFrame:SetPoint("TOPLEFT", "QuestGuru_QuestHistoryTitle"..currHistory, "TOPLEFT", 0, 0);
						QuestGuru_QuestHistorySkillHighlight:SetVertexColor(questHistoryTitle.r, questHistoryTitle.g, questHistoryTitle.b);
						QuestGuru_QuestHistoryHighlightFrame:Show();
						questTitleTag:SetTextColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
						questHistoryTitle:LockHighlight();
					else
						questHistoryTitle:UnlockHighlight();
					end

					currHistory = currHistory + 1;
				end
			else
				if (questHistory.Header ~= currHeader) then
					currHeader = questHistory.Header;
					headCount = headCount + 1;
				end
			end
		else
			if (questHistory.Header ~= currHeader) then
				currHeader = questHistory.Header;
				headCount = headCount + 1;
			end
		end
		if (QuestGuru_HistoryHeaders[questHistory.Header] ~= false) then
			titleCount = titleCount + 1;
		end
		count = count + 1;
	end

	-- ScrollFrame update
	FauxScrollFrame_Update(QuestGuru_QuestHistoryListScrollFrame, titleCount + headCount, QUESTS_DISPLAYED, QUESTLOG_QUEST_HEIGHT, nil, nil, nil, QuestGuru_QuestHistoryHighlightFrame, 293, 316 )
	if ( count == 0 ) then
--		QuestGuru_EmptyQuestLogFrame:Show();
		QuestGuru_QuestHistoryDetailScrollFrame:Hide();
	else
--		QuestGuru_EmptyQuestLogFrame:Hide();
		QuestGuru_QuestHistoryDetailScrollFrame:Show();
	end
	QuestGuru_QuestLogFrameTab2:SetText("History ("..count..")");

	for i=titleCount+headCount+1, QUESTS_DISPLAYED do
		getglobal("QuestGuru_QuestHistoryTitle"..i):Hide();
	end
end

function QuestLog_SetHistorySelection(questID)
	local selectedQuest;
	if ( questID == 0 ) then
		QuestGuru_QuestHistoryDetailScrollFrame:Hide();
		return;
	end

	-- Get xml id
	local id = questID - FauxScrollFrame_GetOffset(QuestGuru_QuestHistoryListScrollFrame);

	QuestGuru_currHistory = questID;
	
	local titleButton = getglobal("QuestGuru_QuestHistoryTitle"..id);
	local titleButtonTag = getglobal("QuestGuru_QuestHistoryTitle"..id.."Tag");

	if ( titleButton.isHeader ) then
		if ( QuestGuru_HistoryHeaders[titleButton:GetText()] == true ) then
			QuestGuru_HistoryHeaders[titleButton:GetText()] = false;
			QuestGuru_UpdateHistory();
			return;
		else
			QuestGuru_HistoryHeaders[titleButton:GetText()] = true;
			QuestGuru_UpdateHistory();
			return;
		end
	else
		-- Set newly selected quest and highlight it
		local scrollFrameOffset = FauxScrollFrame_GetOffset(QuestGuru_QuestHistoryListScrollFrame);
		if ( questID > scrollFrameOffset and questID <= (scrollFrameOffset + QUESTS_DISPLAYED) ) then
			titleButton:LockHighlight();
			titleButtonTag:SetTextColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
			QuestGuru_QuestHistorySkillHighlight:SetVertexColor(titleButton.r, titleButton.g, titleButton.b);
			QuestGuru_QuestHistoryHighlightFrame:SetPoint("TOPLEFT", "QuestGuru_QuestHistoryTitle"..id, "TOPLEFT", 5, 0);
			QuestGuru_QuestHistoryHighlightFrame:Show();
		end
	end
	QuestLog_UpdateQuestHistoryDetails();
end

function QuestLog_UpdateQuestHistoryDetails(doNotScroll)
	local questID = QuestGuru_currHistory;
	local currHeader = "";
	local currHistory = 1;
	local questHistory;
	local questFound = false;
	
	for i, qH in ipairs(QuestGuru_History) do
		if (currHeader ~= qH.Header) then
	      	currHeader = qH.Header;
	      	currHistory = currHistory + 1;
		end
		if (QuestGuru_HistoryHeaders[qH.Header] ~= false) then
			if (currHistory == questID) then
				questHistory = qH;
				questFound = true;
				break;
			end
			currHistory = currHistory + 1;
		end
	end
	
	if (not questFound) then
	    return
	end
	
	local questTitle = questHistory.Title;
	local lastObjective;

-- Added LightHeaded support
if (IsAddOnLoaded("LightHeaded")) then
	if (PanelTemplates_GetSelectedTab(QuestGuru_QuestLogFrame) == 2) then
		if LightHeaded.db.profile.singlepage then
			LightHeaded:UpdateFrame(questTitle, questHistory.Level, nil)
		else
			LightHeaded:UpdateFrame(questTitle, questHistory.Level, 1)
		end
	end
end
-- End LightHeaded support

	if ( not questTitle ) then
		questTitle = "";
	end
	QuestGuru_QuestHistoryQuestTitle:SetText(questTitle);

	local questDescription = gsub(questHistory.Description,"<%name%>",QuestGuru_Player);
	local questObjectives = "Started: "..questHistory.StartTime.."\nFinished: "..questHistory.FinishTime.."\n\n"..gsub(questHistory.ObjectiveText,"<%name%>",QuestGuru_Player);
	QuestGuru_QuestHistoryObjectivesText:SetText(questObjectives);

	QuestGuru_QuestHistoryTimerText:Hide();
	QuestGuru_QuestHistoryObjective1:SetPoint("TOPLEFT", "QuestGuru_QuestHistoryObjectivesText", "BOTTOMLEFT", 0, -10);

	-- Show Quest Watch if track quest is checked
	local numObjectives = questHistory.Objectives;
	local currObj = 0;

	for i=1, 10 do
		getglobal("QuestGuru_QuestHistoryObjective"..i):Hide();
		getglobal("QuestGuru_QuestHistoryObjectiveItem"..i):Hide();
	end

	for i=1, numObjectives, 1 do
		local text = questHistory.Objective[i].Description;
		local type = questHistory.Objective[i].Type;
		if (type ~= "item") then
			currObj = currObj + 1;
			local string = getglobal("QuestGuru_QuestHistoryObjective"..currObj);
			if ( not text or strlen(text) == 0 ) then
				text = type;
			end
			string:SetTextColor(0, 0, 0);
			string:SetText(text);
			string:Show();
			QuestFrame_SetAsLastShown(string);
			lastObjective = string;
		end
	end

	local currObjItem = 0;
	for i=1, numObjectives, 1 do
		local text = questHistory.Objective[i].Description;
		local type = questHistory.Objective[i].Type;
		local texture, link, count;
		if (type == "item") then
			currObjItem = currObjItem + 1;
			local questItem = getglobal("QuestGuru_QuestHistoryObjectiveItem"..currObjItem);
			questItem.type = "required";
			numItems = 1;
			local itemLink = text;
			local numNeeded = questHistory.Objective[i].numNeeded;
			if (not itemLink) then
				texture = "Interface\\Icons\\INV_Misc_QuestionMark";
				count = 0;
			else
				name, link, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, texture = GetItemInfo(itemLink);
				count = GetItemCount(itemLink);
			end
			questItem:SetID(currObjItem)
			questItem:Show();
			-- For the tooltip
			questItem.rewardType = "item"
			questItem.link = itemLink;
			QuestFrame_SetAsLastShown(questItem, spacerFrame);
			getglobal("QuestGuru_QuestHistoryObjectiveItem"..currObjItem.."Name"):SetText(name);
			SetItemButtonCount(questItem, numNeeded+0);
			SetItemButtonTexture(questItem, texture);
			SetItemButtonTextureVertexColor(questItem, 1.0, 1.0, 1.0);
			SetItemButtonNameFrameVertexColor(questItem, 1.0, 1.0, 1.0);
			if ( currObjItem  > 1 ) then
				if ( mod(currObjItem ,2) == 1 ) then
					questItem:SetPoint("TOPLEFT", "QuestGuru_QuestHistoryObjectiveItem"..(currObjItem - 2), "BOTTOMLEFT", 0, -2);
					lastObjective = questItem;
				else
					questItem:SetPoint("TOPLEFT", "QuestGuru_QuestHistoryObjectiveItem"..(currObjItem - 1), "TOPRIGHT", 1, 0);
					lastObjective = getglobal("QuestGuru_QuestHistoryObjectiveItem"..(currObjItem)-1);
				end
			else
				if (currObj > 0) then
					questItem:SetPoint("TOPLEFT", "QuestGuru_QuestHistoryObjective"..currObj, "BOTTOMLEFT", 0, -5);
				else
					questItem:SetPoint("TOPLEFT", "QuestGuru_QuestHistoryObjectivesText", "BOTTOMLEFT", 0, -10);
				end
				lastObjective = questItem;
			end
		end
	end


	-- If there's money required then anchor and display it
	if ( questHistory.RequiredMoney > 0 ) then
		if ( numObjectives > 0 ) then
			QuestGuru_QuestHistoryRequiredMoneyText:SetPoint("TOPLEFT", lastObjective, "BOTTOMLEFT", 0, -4);
		else
			QuestGuru_QuestHistoryRequiredMoneyText:SetPoint("TOPLEFT", "QuestGuru_QuestHistoryObjectivesText", "BOTTOMLEFT", 0, -10);
		end

		MoneyFrame_Update("QuestGuru_QuestHistoryRequiredMoneyFrame", questHistory.RequiredMoney);

		QuestGuru_QuestHistoryRequiredMoneyText:SetTextColor(0.2, 0.2, 0.2);
		SetMoneyFrameColor("QuestGuru_QuestHistoryRequiredMoneyFrame", 1.0, 1.0, 1.0);

		QuestGuru_QuestHistoryRequiredMoneyText:Show();
		QuestGuru_QuestHistoryRequiredMoneyFrame:Show();
	else
		QuestGuru_QuestHistoryRequiredMoneyText:Hide();
		QuestGuru_QuestHistoryRequiredMoneyFrame:Hide();
	end

	if ( questHistory.SuggestedGroup > 0 ) then
		local suggestedGroupString = format(QUEST_SUGGESTED_GROUP_NUM, questHistory.SuggestedGroup);
		QuestGuru_QuestHistorySuggestedGroupNum:SetText(suggestedGroupString);
		QuestGuru_QuestHistorySuggestedGroupNum:Show();
		QuestGuru_QuestHistorySuggestedGroupNum:ClearAllPoints();
		if ( questHistory.RequiredMoney > 0 ) then
			QuestGuru_QuestHistorySuggestedGroupNum:SetPoint("TOPLEFT", "QuestGuru_QuestHistoryRequiredMoneyText", "BOTTOMLEFT", 0, -4);
		elseif ( numObjectives > 0 ) then
			QuestGuru_QuestHistorySuggestedGroupNum:SetPoint("TOPLEFT", lastObjective, "BOTTOMLEFT", 0, -4);
		else
			QuestGuru_QuestHistorySuggestedGroupNum:SetPoint("TOPLEFT", "QuestGuru_QuestHistoryObjectivesText", "BOTTOMLEFT", 0, -10);
		end
	else
		QuestGuru_QuestHistorySuggestedGroupNum:Hide();
	end

	if ( questHistory.SuggestedGroup > 0 ) then
		QuestGuru_QuestHistoryDescriptionTitle:SetPoint("TOPLEFT", "QuestGuru_QuestHistorySuggestedGroupNum", "BOTTOMLEFT", 0, -10);
	elseif ( questHistory.RequiredMoney > 0 ) then
		QuestGuru_QuestHistoryDescriptionTitle:SetPoint("TOPLEFT", "QuestGuru_QuestHistoryRequiredMoneyText", "BOTTOMLEFT", 0, -10);
	elseif ( numObjectives > 0 ) then
		QuestGuru_QuestHistoryDescriptionTitle:SetPoint("TOPLEFT", lastObjective, "BOTTOMLEFT", 0, -10);
	else
		QuestGuru_QuestHistoryDescriptionTitle:SetPoint("TOPLEFT", "QuestGuru_QuestHistoryObjectivesText", "BOTTOMLEFT", 0, -10);
	end
	if ( questDescription ) then
		QuestGuru_QuestHistoryQuestDescription:SetText(questDescription);
		QuestFrame_SetAsLastShown(QuestGuru_QuestHistoryQuestDescription);
	end
	local numRewards = questHistory.Rewards;
	local numChoices = questHistory.Choices;
	local money = questHistory.RewardMoney;

	if ( (numRewards + numChoices + money) > 0 ) then
		QuestGuru_QuestHistoryRewardTitleText:Show();
		QuestFrame_SetAsLastShown(QuestGuru_QuestHistoryRewardTitleText);
	else
		QuestGuru_QuestHistoryRewardTitleText:Hide();
	end

	QuestGuru_QuestHistoryFrameItems_Update("QuestHistory");
	if ( not doNotScroll ) then
		QuestGuru_QuestHistoryDetailScrollFrameScrollBar:SetValue(0);
	end
	QuestGuru_QuestHistoryDetailScrollFrame:UpdateScrollChildRect();
end

function QuestGuru_QuestHistoryFrameItems_Update(questState)
	local isQuestLog = 0;
	local questHistory;
	
	if ( questState == "QuestHistory" ) then
		isQuestLog = 1;
		questState = "QuestGuru_QuestHistory";
	end

	local questID = QuestGuru_currHistory;
	local currHeader = "";
	local currHistory = 1;

	for i, qH in ipairs(QuestGuru_History) do
		if (currHeader ~= qH.Header) then
	      	currHeader = qH.Header;
	      	currHistory = currHistory + 1;
		end
		if (QuestGuru_HistoryHeaders[qH.Header] ~= false) then
			if (currHistory == questID) then
				questHistory = qH;
				questFound = true;
				break;
			end
			currHistory = currHistory + 1;
		end
	end
	
	if (not questFound) then
	    return
	end

	local numQuestRewards = questHistory.Rewards;
	local numQuestChoices = questHistory.Choices;
	local numQuestSpellRewards = questHistory.SpellRewards;
	local money = questHistory.RewardMoney;
	local spacerFrame = QuestGuru_QuestHistorySpacerFrame;

	local totalRewards = numQuestRewards + numQuestChoices + numQuestSpellRewards;
	local questItemName = questState.."Item";
	local material = QuestFrame_GetMaterial();
	local questItemReceiveText = getglobal(questState.."ItemReceiveText")
	if ( totalRewards == 0 and money == 0 ) then
		getglobal(questState.."RewardTitleText"):Hide();
	else
		getglobal(questState.."RewardTitleText"):Show();
		QuestFrame_SetTitleTextColor(getglobal(questState.."RewardTitleText"), material);
		QuestFrame_SetAsLastShown(getglobal(questState.."RewardTitleText"), spacerFrame);
	end
	if ( money == 0 ) then
		getglobal(questState.."MoneyFrame"):Hide();
	else
		getglobal(questState.."MoneyFrame"):Show();
		QuestFrame_SetAsLastShown(getglobal(questState.."MoneyFrame"), spacerFrame);
		MoneyFrame_Update(questState.."MoneyFrame", money);
	end

	-- Hide unused rewards
	for i=totalRewards + 1, MAX_NUM_ITEMS, 1 do
		getglobal(questItemName..i):Hide();
	end

	local questItem, name, texture, isTradeskillSpell, isSpellLearned, quality, isUsable, numItems = 1;
	local rewardsCount = 0;

	-- Setup choosable rewards
	if ( numQuestChoices > 0 ) then
		local itemChooseText = getglobal(questState.."ItemChooseText");
		itemChooseText:Show();
		QuestFrame_SetTextColor(itemChooseText, material);
		QuestFrame_SetAsLastShown(itemChooseText, spacerFrame);

		local index;
		local baseIndex = rewardsCount;
		for i=1, numQuestChoices, 1 do
			index = i + baseIndex;
			questItem = getglobal(questItemName..index);
			questItem.type = "choice";
			name, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, texture = GetItemInfo(questHistory.Choice[i].Link)
			numItems = questHistory.Choice[i].Count;

			questItem:SetID(i)
			questItem:Show();
			-- For the tooltip
			questItem.rewardType = "item"
			QuestFrame_SetAsLastShown(questItem, spacerFrame);
			getglobal(questItemName..index.."Name"):SetText(name);
			SetItemButtonCount(questItem, numItems);
			SetItemButtonTexture(questItem, texture);
			questItem.link = questHistory.Choice[i].Link;
--			if ( IsEquippableItem(itemLink) or IsConsumableItem(itemLink) ) then
				SetItemButtonTextureVertexColor(questItem, 1.0, 1.0, 1.0);
				SetItemButtonNameFrameVertexColor(questItem, 1.0, 1.0, 1.0);
--			else
--				SetItemButtonTextureVertexColor(questItem, 0.9, 0, 0);
--				SetItemButtonNameFrameVertexColor(questItem, 0.9, 0, 0);
--			end
			if ( i > 1 ) then
				if ( mod(i,2) == 1 ) then
					questItem:SetPoint("TOPLEFT", questItemName..(index - 2), "BOTTOMLEFT", 0, -2);
				else
					questItem:SetPoint("TOPLEFT", questItemName..(index - 1), "TOPRIGHT", 1, 0);
				end
			else
				questItem:SetPoint("TOPLEFT", itemChooseText, "BOTTOMLEFT", -3, -5);
			end
			rewardsCount = rewardsCount + 1;
		end
	else
		getglobal(questState.."ItemChooseText"):Hide();
	end

	-- Setup spell rewards
	if ( numQuestSpellRewards > 0 ) then
		local learnSpellText = getglobal(questState.."SpellLearnText");
		learnSpellText:Show();
		QuestFrame_SetTextColor(learnSpellText, material);
		QuestFrame_SetAsLastShown(learnSpellText, spacerFrame);

		--Anchor learnSpellText if there were choosable rewards
		if ( rewardsCount > 0 ) then
			learnSpellText:SetPoint("TOPLEFT", questItemName..rewardsCount, "BOTTOMLEFT", 3, -5);
		else
			learnSpellText:SetPoint("TOPLEFT", questState.."RewardTitleText", "BOTTOMLEFT", 0, -5);
		end

		texture = questHistory.SpellReward.Texture;
		name = questHistory.SpellReward.Name;

		learnSpellText:SetText(name);

		rewardsCount = rewardsCount + 1;
		questItem = getglobal(questItemName..rewardsCount);
		questItem:Show();
		-- For the tooltip
		questItem.link = "";
		questItem.rewardType = "spell";
		SetItemButtonCount(questItem, 0);
		SetItemButtonTexture(questItem, texture);
		getglobal(questItemName..rewardsCount.."Name"):SetText(name);
		questItem:SetPoint("TOPLEFT", learnSpellText, "BOTTOMLEFT", -3, -5);
	else
		getglobal(questState.."SpellLearnText"):Hide();
	end

	-- Setup mandatory rewards
	if ( numQuestRewards > 0 or money > 0) then
		QuestFrame_SetTextColor(questItemReceiveText, material);
		-- Anchor the reward text differently if there are choosable rewards
		if ( numQuestSpellRewards > 0  ) then
			questItemReceiveText:SetText(REWARD_ITEMS);
			questItemReceiveText:SetPoint("TOPLEFT", questItemName..rewardsCount, "BOTTOMLEFT", 3, -5);
		elseif ( numQuestChoices > 0  ) then
			questItemReceiveText:SetText(REWARD_ITEMS);
			local index = numQuestChoices;
			if ( mod(index, 2) == 0 ) then
				index = index - 1;
			end
			questItemReceiveText:SetPoint("TOPLEFT", questItemName..index, "BOTTOMLEFT", 3, -5);
		else
			questItemReceiveText:SetText(REWARD_ITEMS_ONLY);
			questItemReceiveText:SetPoint("TOPLEFT", questState.."RewardTitleText", "BOTTOMLEFT", 3, -5);
		end
		questItemReceiveText:Show();
		QuestFrame_SetAsLastShown(questItemReceiveText, spacerFrame);
		-- Setup mandatory rewards
		local index;
		local baseIndex = rewardsCount;
		for i=1, numQuestRewards, 1 do
			index = i + baseIndex;
			questItem = getglobal(questItemName..index);

			questItem.type = "reward";
			name, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, texture = GetItemInfo(questHistory.Reward[i].Link);
			numItems = questHistory.Reward[i].Count;

			questItem:SetID(i)
			questItem:Show();
			-- For the tooltip
			questItem.link = questHistory.Reward[i].Link;
			questItem.rewardType = "item";
			QuestFrame_SetAsLastShown(questItem, spacerFrame);
			getglobal(questItemName..index.."Name"):SetText(name);
			SetItemButtonCount(questItem, numItems);
			SetItemButtonTexture(questItem, texture);
--			if ( IsEquippableItem(itemLink) or IsConsumableItem(itemLink) ) then
				SetItemButtonTextureVertexColor(questItem, 1.0, 1.0, 1.0);
				SetItemButtonNameFrameVertexColor(questItem, 1.0, 1.0, 1.0);
--			else
--				SetItemButtonTextureVertexColor(questItem, 0.5, 0, 0);
--				SetItemButtonNameFrameVertexColor(questItem, 1.0, 0, 0);
--			end

			if ( i > 1 ) then
				if ( mod(i,2) == 1 ) then
					questItem:SetPoint("TOPLEFT", questItemName..(index - 2), "BOTTOMLEFT", 0, -2);
				else
					questItem:SetPoint("TOPLEFT", questItemName..(index - 1), "TOPRIGHT", 1, 0);
				end
			else
				questItem:SetPoint("TOPLEFT", questState.."ItemReceiveText", "BOTTOMLEFT", -3, -5);
			end
			rewardsCount = rewardsCount + 1;
		end
	else
		questItemReceiveText:Hide();
	end
end

function QuestGuru_CheckHistoryVersion()
	local i, qH;
	
	if (QuestGuru_History.Version == nil) then
		for i, qH in ipairs(QuestGuru_History) do
			qH.Description = gsub(qH.Description,QuestGuru_Player,"<%name%>");
			qH.ObjectiveText = gsub(qH.ObjectiveText,QuestGuru_Player,"<%name%>");
			qH.StartTime = date("%m/%d/%Y %H:%M:%S");
			qH.FinishTime = date("%m/%d/%Y %H:%M:%S");
			if (qH.Daily == 1 and qH.Count == nil) then
				qH.Count = 1;
			end
		end
		QuestGuru_History.Version = 2;
	end
end