function QuestGuru_OptionsFrameTrackerBorderDropDown_Initialize()
	local info = UIDropDownMenu_CreateInfo();

	info.text = "None";
	info.func = QuestGuru_OptionsFrameTrackerBorderDropDownButton_OnClick;
	info.checked = checked;
	UIDropDownMenu_AddButton(info);

	info.text = "Single";
	info.func = QuestGuru_OptionsFrameTrackerBorderDropDownButton_OnClick;
	info.checked = checked;
	UIDropDownMenu_AddButton(info);
end

function QuestGuru_OptionsFrameTrackerBorderDropDownButton_OnClick()
	UIDropDownMenu_SetSelectedID(QuestGuru_OptionsFrameTrackerBorderDropDown, this:GetID());
	QuestGuru_Settings.Tracker.BorderStyle = this:GetID();
	QuestGuru_SetWatchBorder(QuestGuru_Settings.Tracker.BorderStyle);
end

do
	local temp, i;

	QuestGuru_OptionsFrame = CreateFrame("FRAME", "QuestGuru_OptionsFrame", UIParent);
	QuestGuru_OptionsFrame:Hide();
	QuestGuru_OptionsFrame:EnableMouse();
	QuestGuru_OptionsFrame:SetMovable(1);
	QuestGuru_OptionsFrame:SetToplevel(1);
	QuestGuru_OptionsFrame:SetClampedToScreen(true);
	QuestGuru_OptionsFrame:SetWidth(300);
	QuestGuru_OptionsFrame:SetHeight(300);
	QuestGuru_OptionsFrame:SetPoint("CENTER", UIParent, "CENTER", 0, 10);
	QuestGuru_OptionsFrame:SetBackdrop({
		bgFile="Interface\\Characterframe\\UI-Party-Background",
		edgeFile="Interface\\DialogFrame\\UI-DialogBox-Border",
--		tile=1, tileSize=32, edgeSize=16,
		insets={left=11, right=12, top=12, bottom=11}
	});
	QuestGuru_OptionsFrame:SetBackdropColor(0,0,0,0.9);
	
	QuestGuru_OptionsFrame:RegisterForDrag("LeftButton");
	QuestGuru_OptionsFrame:SetScript("OnDragStart",
		function ()
			this:StartMoving();
			this.isMoving = true;
 		end);
 	QuestGuru_OptionsFrame:SetScript("OnDragStop",
 		function ()
			this:StopMovingOrSizing();
			this.isMoving = false;
		end);
		
	temp = QuestGuru_OptionsFrame:CreateTexture("QuestGuru_OptionsFrameHeader", "ARTWORK");
	temp:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Header");
	temp:SetWidth(356);
	temp:SetHeight(64);
	temp:SetPoint("TOP", 0, 12);
	
	temp = QuestGuru_OptionsFrame:CreateFontString("QuestGuru_OptionsFrameTitle", "ARTWORK", "GameFontNormal");
	temp:SetText("QuestGuru Options");
	temp:SetPoint("TOP", "QuestGuru_OptionsFrameHeader", "TOP", 0, -14);
	
	QuestGuru_OptionsFrameExit = CreateFrame("BUTTON", "QuestGuru_OptionsFrameExit", QuestGuru_OptionsFrame, "UIPanelButtonTemplate");
	QuestGuru_OptionsFrameExit:SetWidth(77);
	QuestGuru_OptionsFrameExit:SetHeight(21);
	QuestGuru_OptionsFrameExit:SetText("Close");
	QuestGuru_OptionsFrameExit:SetPoint("CENTER", "QuestGuru_OptionsFrame", "BOTTOM", 0, 32);
	QuestGuru_OptionsFrameExit:SetScript("OnClick",
		function ()
			QuestGuru_OptionsFrame:Hide();
		end);


---------------------
-- General Options --
---------------------
	QuestGuru_OptionsFrameTabPage1 = CreateFrame("FRAME", "QuestGuru_OptionsFrameTabPage1", QuestGuru_OptionsFrame);
	QuestGuru_OptionsFrameTabPage1:SetAllPoints();
	QuestGuru_OptionsFrameTabPage1:Show();

	temp = QuestGuru_OptionsFrameTabPage1:CreateFontString(nil, "ARTWORK", "GameFontNormal");
	temp:SetPoint("CENTER", QuestGuru_OptionsFrameTabPage1, "TOP", 0, -38);
	temp:SetText("General Options coming soon...");


---------------------
-- Tracker Options --
---------------------
	QuestGuru_OptionsFrameTabPage2 = CreateFrame("FRAME", "QuestGuru_OptionsFrameTabPage2", QuestGuru_OptionsFrame);
	QuestGuru_OptionsFrameTabPage2:SetAllPoints();
	QuestGuru_OptionsFrameTabPage2:Hide();

	temp = QuestGuru_OptionsFrameTabPage2:CreateFontString(nil, "ARTWORK", "GameFontNormal");
	temp:SetPoint("CENTER", QuestGuru_OptionsFrameTabPage2, "TOP", 0, -38);
	temp:SetText("Tracker Options");

	QuestGuru_OptionsFrameTrackerEnabledToggle = CreateFrame("CheckButton", "QuestGuru_OptionsFrameTrackerEnabledToggle", QuestGuru_OptionsFrameTabPage2, "OptionsCheckButtonTemplate");
	QuestGuru_OptionsFrameTrackerEnabledToggle:SetPoint("TOPLEFT", 30, -52);
	QuestGuru_OptionsFrameTrackerEnabledToggleText:SetText("Use QuestGuru tracker");
	QuestGuru_OptionsFrameTrackerEnabledToggle:SetScript("OnClick",
		function ()
			if (QuestGuru_OptionsFrameTrackerEnabledToggle:GetChecked()) then
				QuestGuru_Settings.Tracker.Enabled = true;
			else
				QuestGuru_Settings.Tracker.Enabled = false;
			end
			QuestWatch_Update();
		end);

	QuestGuru_OptionsFrameTrackerHeadersToggle = CreateFrame("CheckButton", "QuestGuru_OptionsFrameTrackerHeadersToggle", QuestGuru_OptionsFrameTabPage2, "OptionsCheckButtonTemplate");
	QuestGuru_OptionsFrameTrackerHeadersToggle:SetPoint("TOPLEFT", QuestGuru_OptionsFrameTrackerEnabledToggle, "BOTTOMLEFT", 0, 0);
	QuestGuru_OptionsFrameTrackerHeadersToggleText:SetText("Show Headers");
	QuestGuru_OptionsFrameTrackerHeadersToggle:SetScript("OnClick",
		function ()
			if (QuestGuru_OptionsFrameTrackerHeadersToggle:GetChecked()) then
				QuestGuru_Settings.Tracker.ShowHeaders = true;
			else
				QuestGuru_Settings.Tracker.ShowHeaders = false;
			end
			QuestWatch_Update();
		end);
	
	QuestGuru_OptionsFrameTrackerBorderStyleText = QuestGuru_OptionsFrameTabPage2:CreateFontString("QuestGuru_OptionsFrameTrackerBorderStyleText", "ARTWORK", "GameFontNormalSmall");
	QuestGuru_OptionsFrameTrackerBorderStyleText:SetPoint("TOPLEFT", QuestGuru_OptionsFrameTrackerHeadersToggle, "BOTTOMLEFT", 0, -16);
	QuestGuru_OptionsFrameTrackerBorderStyleText:SetText("Border style: ");
	
	QuestGuru_OptionsFrameTrackerBorderDropDown = CreateFrame("FRAME", "QuestGuru_OptionsFrameTrackerBorderDropDown", QuestGuru_OptionsFrameTabPage2, "UIDropDownMenuTemplate");
	QuestGuru_OptionsFrameTrackerBorderDropDown:SetID(1);
	QuestGuru_OptionsFrameTrackerBorderDropDown:SetPoint("LEFT", QuestGuru_OptionsFrameTrackerBorderStyleText, "RIGHT", -10, -2);
	temp = QuestGuru_OptionsFrameTrackerBorderDropDown:CreateTexture("QuestGuru_OptionsFrameTrackerBorderDropDownHighlightTexture", "OVERLAY");
	temp:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-Tab-Highlight");
	temp:Hide();
	temp:SetPoint("TOPLEFT", 15, 3);
	temp:SetPoint("BOTTOMRIGHT", -30, -2);
	
	QuestGuru_OptionsFrameTrackerBorderDropDown:SetScript("OnEnter",
		function ()
			QuestGuru_OptionsFrameTrackerBorderDropDownHighlightTexture:Show();
		end);
	QuestGuru_OptionsFrameTrackerBorderDropDown:SetScript("OnLeave",
		function ()
			QuestGuru_OptionsFrameTrackerBorderDropDownHighlightTexture:Hide();
		end);
	QuestGuru_OptionsFrameTrackerBorderDropDown:SetScript("OnShow",
		function ()
			UIDropDownMenu_Initialize(QuestGuru_OptionsFrameTrackerBorderDropDown, QuestGuru_OptionsFrameTrackerBorderDropDown_Initialize);
			UIDropDownMenu_SetSelectedID(QuestGuru_OptionsFrameTrackerBorderDropDown, QuestGuru_Settings.Tracker.BorderStyle);
		end);
	UIDropDownMenu_Initialize(QuestGuru_OptionsFrameTrackerBorderDropDown, QuestGuru_OptionsFrameTrackerBorderDropDown_Initialize);
	UIDropDownMenu_JustifyText("LEFT", QuestGuru_OptionsFrameTrackerBorderDropDown);
		
	QuestGuru_OptionsFrameTrackerAlpha = CreateFrame("Slider", "QuestGuru_OptionsFrameTrackerAlpha", QuestGuru_OptionsFrameTabPage2, "OptionsSliderTemplate");
	QuestGuru_OptionsFrameTrackerAlpha:SetWidth(220);
	QuestGuru_OptionsFrameTrackerAlpha:SetHeight(16);
	QuestGuru_OptionsFrameTrackerAlpha:SetPoint("CENTER", QuestGuru_OptionsFrameTabPage2, "BOTTOM", 0, 70);
	QuestGuru_OptionsFrameTrackerAlphaText:SetText("Background Alpha");
	QuestGuru_OptionsFrameTrackerAlphaHigh:SetText("100%");
	QuestGuru_OptionsFrameTrackerAlphaLow:SetText("0%");
	QuestGuru_OptionsFrameTrackerAlpha:SetMinMaxValues(0,1);
	QuestGuru_OptionsFrameTrackerAlpha:SetValueStep(0.1);
	QuestGuru_OptionsFrameTrackerAlpha:SetValue(0.7);
	QuestGuru_OptionsFrameTrackerAlpha:SetScript("OnValueChanged",
		function ()
			QuestGuru_Settings.Tracker.Alpha = QuestGuru_OptionsFrameTrackerAlpha:GetValue();
			QuestGuru_QuestWatchFrame:SetBackdropColor(0,0,0,QuestGuru_Settings.Tracker.Alpha);
			QuestGuru_OptionsFrameTrackerAlphaText:SetText("Background Alpha ("..abs(ceil((QuestGuru_Settings.Tracker.Alpha * 100)-0.5)).."%)");
		end);

	QuestGuru_OptionsFrameTrackerScale = CreateFrame("Slider", "QuestGuru_OptionsFrameTrackerScale", QuestGuru_OptionsFrameTabPage2, "OptionsSliderTemplate");
	QuestGuru_OptionsFrameTrackerScale:SetWidth(220);
	QuestGuru_OptionsFrameTrackerScale:SetHeight(16);
	QuestGuru_OptionsFrameTrackerScale:SetPoint("CENTER", QuestGuru_OptionsFrameTabPage2, "BOTTOM", 0, 120);
	QuestGuru_OptionsFrameTrackerScaleText:SetText("Tracker Size");
	QuestGuru_OptionsFrameTrackerScaleHigh:SetText("150%");
	QuestGuru_OptionsFrameTrackerScaleLow:SetText("50%");
	QuestGuru_OptionsFrameTrackerScale:SetMinMaxValues(0.5,1.5);
	QuestGuru_OptionsFrameTrackerScale:SetValueStep(0.1);
	QuestGuru_OptionsFrameTrackerScale:SetValue(0.9);
	QuestGuru_OptionsFrameTrackerScale:SetScript("OnValueChanged",
		function ()
			QuestGuru_Settings.Tracker.Scale = QuestGuru_OptionsFrameTrackerScale:GetValue();
			QuestGuru_OptionsFrameTrackerScaleText:SetText("Tracker Size ("..ceil((QuestGuru_Settings.Tracker.Scale * 100)-0.5).."%)");
			QuestGuru_QuestWatchFrame:SetScale(QuestGuru_Settings.Tracker.Scale);
--			QuestGuru_QuestWatchFrame:ClearAllPoints();
--			QuestGuru_QuestWatchFrame:SetPoint("TOPLEFT", "UIParent", "BOTTOMLEFT", QuestGuru_Settings.Tracker.Left, QuestGuru_Settings.Tracker.Top);
		end);

	
----------
-- Tabs --
----------

	QuestGuru_OptionsFrameTab1 = CreateFrame("BUTTON", "QuestGuru_OptionsFrameTab1", QuestGuru_OptionsFrame, "CharacterFrameTabButtonTemplate");
	QuestGuru_OptionsFrameTab1:SetID(1);
	QuestGuru_OptionsFrameTab1:SetText("General");
	QuestGuru_OptionsFrameTab1:SetPoint("TOPLEFT", "QuestGuru_OptionsFrame", "BOTTOMLEFT", 20, 8);
	QuestGuru_OptionsFrameTab1:SetScript("OnClick",
		function ()
			PanelTemplates_SetTab(QuestGuru_OptionsFrame, 1);
			QuestGuru_OptionsFrameTabPage1:Show();
			QuestGuru_OptionsFrameTabPage2:Hide();
		end);
	QuestGuru_OptionsFrameTab2 = CreateFrame("BUTTON", "QuestGuru_OptionsFrameTab2", QuestGuru_OptionsFrame, "CharacterFrameTabButtonTemplate");
	QuestGuru_OptionsFrameTab2:SetID(2);
	QuestGuru_OptionsFrameTab2:SetText("Tracker");
	QuestGuru_OptionsFrameTab2:SetPoint("LEFT", "QuestGuru_OptionsFrameTab1", "RIGHT", -12, 0);
	QuestGuru_OptionsFrameTab2:SetScript("OnClick",
		function ()
			PanelTemplates_SetTab(QuestGuru_OptionsFrame, 2);
			QuestGuru_OptionsFrameTabPage1:Hide();
			QuestGuru_OptionsFrameTabPage2:Show();
		end);


	tinsert(UISpecialFrames, "QuestGuru_OptionsFrame");
	QuestGuru_OptionsFrame.elapsed = 0;
    PanelTemplates_SetNumTabs(QuestGuru_OptionsFrame, 2);
    PanelTemplates_SetTab(QuestGuru_OptionsFrame, 1);
end